services:
  - docker:dind

stages:
  - dependencies
  - build
  - publish
#set up the core application
install_dependencies:
  #This stage will run on node:16-alpine docker image 
  image: node:16-alpine
  #where we should run this instruction
  stage: dependencies
  #run on a given image using the given package.json file.
  script:
    - npm install
  only:
    - master
  #triggered upon any changes on package-lock.json 
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules

build_image:
  image: node:16-alpine
  stage: build
  script:
    - npm link @angular/cli@11.2.6
    - npm run build
  #This will be gather everything under the dist folder and mark it as artifacts for the project
  artifacts:
    paths:
      - $CI_PROJECT_DIR/dist
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules
    policy: pull

push-docker-registry:
  image: docker:latest
  stage: publish
  only:
    - master
  script:
    - docker build -t registry.https://gitlab.com/rim.reliefapps/my-awesome-frontemd-video-player .
    - docker login -u rim.reliefapps -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker push registry.https://gitlab.com/rim.reliefapps/my-awesome-frontemd-video-player